<template>
  <b-container>
    <div class="pageTitle">
      <h1>        
        <b-icon-calendar-3/>
        Minhas Consultas
      </h1>
      <div class="pageTitle__view">
        <b-button :variant="isList ? 'primary' : 'secondary'" squared size="sm" @click="isList = true">
          <b-icon-hdd-stack-fill />
        </b-button>
        <b-button :variant="!isList ? 'primary' : 'secondary'" @click="isList = false" squared size="sm">
          <b-icon-grid-fill />
        </b-button>
      </div>
    </div>
    <b-alert :show="loading || alertShow" :variant="alertVariant">
      <b-spinner small variant="secondary" v-if="alertVariant === 'secondary' && loading" />
      {{ alertMessage }}
    </b-alert>
    <div v-if="!loading && appointmentList.length > 0">
      <appointment-list v-if="isList" :list="appointmentList" />
      <appointment-grid v-else :list="appointmentList" />
    </div>
  </b-container>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
import AppointmentList from './../../components/list/AppointmentList'
import AppointmentGrid from './../../components/list/AppointmentGrid'

export default {
  components: {
    AppointmentGrid,
    AppointmentList
  },

  computed: {
    ...mapGetters('appointment', ['getAppointmentList']),
    appointmentList() {
      return this.getAppointmentList.map(apt => {
        const dataArray = apt.dataConsulta.split(' ')
        const  { medico: { nome }, paciente, id, observacao } = apt

        return {
          id,
          hour: dataArray[1],
          date: dataArray[0],
          doctor: nome,
          pacient: paciente,
          observation: observacao
        }
      })
    }
  },

  methods: {
    ...mapActions('appointment', ['listAppointments']),
    async setupAppointmentList() {
      this.loading = true

      const { success, message } = await this.listAppointments()

      this.loading = false

      if (!success) {
        this.showAlert(message, 'danger')
      } else {
        if (this.appointmentList.length === 0) {
          this.showAlert('Nenhuma consulta cadastrada', 'secondary')
        }
      }
    },

    showAlert(message, variant) {
      this.alertMessage = message
      this.alertVariant = variant

      setTimeout(() => {
        this.alertShow = true
      }, 100);
    }
  },

  mounted() {
    this.setupAppointmentList()
  },

  data() {
    return {
      alertVariant: 'secondary',
      alertMessage: 'Carregando consultas',
      alertShow: false,
      loading: false,
      isList: true
    }
  }
}
</script>

<style>

</style>